// Copyright (c) 2014  David Muse
// See the file COPYING for more information

#ifndef SQLRAUTHS_H
#define SQLRAUTHS_H

#include <sqlrelay/private/sqlrserverdll.h>

#include <rudiments/xmldom.h>
#include <rudiments/singlylinkedlist.h>
#include <rudiments/dynamiclib.h>
#include <sqlrelay/sqlrpwdencs.h>
#include <sqlrelay/sqlrauth.h>

class SQLRSERVER_DLLSPEC sqlrauthplugin {
	public:
		sqlrauth	*au;
		dynamiclib	*dl;
};

class SQLRSERVER_DLLSPEC sqlrauths {
	public:
			sqlrauths();
			~sqlrauths();

		bool	loadAuthenticators(const char *auths,
						sqlrpwdencs *sqlrpe);
		bool	authenticate(const char *user, const char *password);
	private:
		void	unloadAuthenticators();
		void	loadAuthenticator(xmldomnode *auth,
						sqlrpwdencs *sqlrpe);

		xmldom					*xmld;
		singlylinkedlist< sqlrauthplugin * >	llist;
};

#endif
